码迷,mamicode.com
首页 > 其他好文 > 详细

LeetCode:First Bad Version

时间:2016-07-10 18:47:43      阅读:152      评论:0      收藏:0      [点我收藏+]

标签:

First Bad Version

  • Total Accepted: 50887
  • Total Submissions:222393
  • Difficulty: Easy

You are a product manager and currently leading a team to develop a new product. Unfortunately, 

the latest version of your product fails the quality check. Since each version is developed based on the previous version, 

all the versions after a bad version are also bad.

Suppose you have n versions [1, 2, ..., n] and you want to find out the first bad one, 

which causes all the following ones to be bad.

You are given an API bool isBadVersion(version) which will return whether version is bad. 

Implement a function to find the first bad version. You should minimize the number of calls to the API.

Credits:
Special thanks to @jianchao.li.fighter for adding this problem and creating all test cases.

Subscribe to see which companies asked this question

Hide Tags
 Binary Search




























思路:

二分查找。但是直接用mid = (lo + hi) / 2,可能会溢出。

因此等式替换为:mid = lo + (hi - lo) / 2,可防止溢出。


java code:

/* The isBadVersion API is defined in the parent class VersionControl.
      boolean isBadVersion(int version); */

public class Solution extends VersionControl {
    public int firstBadVersion(int n) {
        
        int lo = 1, hi = n;
        
        while(lo <= hi) {
            int mid  = lo + ((hi - lo)>>1); // 防溢出
            if(isBadVersion(mid))
                hi = mid - 1;
            else
                lo = mid + 1;
        }
        
        return lo;
    }
}


LeetCode:First Bad Version

标签:

原文地址:http://blog.csdn.net/itismelzp/article/details/51868949

(0)
(0)
   
举报
评论 一句话评论(0
登录后才能评论!
© 2014 mamicode.com 版权所有  联系我们:gaon5@hotmail.com
迷上了代码!